<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" creationComplete="creationCompleteHandler(event)" title="Pesquisa de Vendedor" xmlns:visual="br.com.desenv.framework.component.visual.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="VendedorSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			
			import br.com.desenv.nepalign.vo.EmpresaFisica;
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.Usuario;
			import br.com.desenv.nepalign.vo.Vendedor;
			
			[Bindable]
			public var listaVendedor: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			
			[Bindable]
			private var listaUsuarioPesquisa: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaEmpresaFisicaPesquisa: ArrayCollection = new ArrayCollection();

			
			private var vendedorComponenteDetalhe: VendedorComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
			public var vendedor:Vendedor = new Vendedor();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): Vendedor
			{
				var vendedorFiltro: Vendedor = new Vendedor();
				
				vendedorFiltro.empresaFisica = dsvPerfilEmpresa.recuperarEmpresaFisicaSelecionada;
				vendedorFiltro.nome = ignTextInputNomePesquisa.text == ""?null:ignTextInputNomePesquisa.text;
				vendedorFiltro.codigoVendedorCache =  ignTextInputIntegerCodigoVendedorCachePesquisa.text == ""?NaN:parseInt(ignTextInputIntegerCodigoVendedorCachePesquisa.text);
				vendedorFiltro.usuario = ignComboBoxAutoCompleteUsuarioPesquisa.selectedItem; 
				return vendedorFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectVendedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vendedorService", listarResultHandler);	
				
				var remoteObjectUsuario: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioService", listarUsuarioPesquisaResultHandler);	
				remoteObjectUsuario.getOperation("listar").send();
				var remoteObjectEmpresaFisica: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("empresaFisicaService", listarEmpresaFisicaPesquisaResultHandler);	
				remoteObjectEmpresaFisica.getOperation("listar").send();
				
				if(this.vendedor == null)
					this.vendedor = new Vendedor();

				remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, this.vendedor); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaVendedor: Page = event.result as Page;
				pageNumber = paginaVendedor.pageNumber;
				totalRecords = paginaVendedor.totalRecords;
				lastPage = paginaVendedor.lastPage();
				listaVendedor = paginaVendedor.recordList;
				labelPaginaAtual.text = "" + paginaVendedor.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaVendedor.totalRecords;
			}

// CARREGANDO COMBOS			
			private function listarUsuarioPesquisaResultHandler( event: ResultEvent ): void 
			{
				listaUsuarioPesquisa = event.result as ArrayCollection;
				listaUsuarioPesquisa.addItemAt(null, 0);
			}
			private function listarEmpresaFisicaPesquisaResultHandler( event: ResultEvent ): void 
			{
				listaEmpresaFisicaPesquisa = event.result as ArrayCollection;
				listaEmpresaFisicaPesquisa.addItemAt(null, 0);
			}

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectVendedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vendedorService", listarResultHandler);	
					remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var vendedorComponenteCadastro: VendedorComponenteCadastro = new VendedorComponenteCadastro();
				vendedorComponenteCadastro.vendedor = new Vendedor(); 
				vendedorComponenteCadastro.addEventListener("VendedorIncluidoEvent", atualizarListaVendedorPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(vendedorComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(vendedorComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var vendedorSelecionado: Vendedor = datagridListaVendedor.selectedItem as Vendedor;
				this.dispatchEvent(new ResultEvent("VendedorSelecionadoEvent",false, true, vendedorSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaVendedor_doubleClickHandler(event:MouseEvent):void
			{
				vendedorComponenteDetalhe = new VendedorComponenteDetalhe();
				vendedorComponenteDetalhe.vendedor = datagridListaVendedor.selectedItem as Vendedor;
				vendedorComponenteDetalhe.addEventListener("VendedorExcluidoEvent", atualizarListaVendedorPorExclusaoResultHandler);
				vendedorComponenteDetalhe.addEventListener("VendedorAtualizadoEvent", atualizarListaVendedorPorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(vendedorComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(vendedorComponenteDetalhe);
			}
			
			
			private function atualizarListaVendedorPorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectVendedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vendedorService", listarResultHandler);	
				remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaVendedorPorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectVendedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vendedorService", listarResultHandler);	
				remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaVendedorPorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectVendedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vendedorService", listarResultHandler);	
				remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectVendedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vendedorService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectVendedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vendedorService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectVendedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vendedorService", listarResultHandler);	
				remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectVendedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("vendedorService", listarResultHandler);	
				remoteObjectVendedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Empresa:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<visual:DsvPerfilEmpresa id="dsvPerfilEmpresa" tipoPesquisa="{DsvPerfilEmpresa.LISTAR_APENAS_LOJAS}"/>
			</mx:GridItem>		
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Nome:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoNomePesquisa" styleName="labelValidacao" text="{ignTextInputNomePesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputNomePesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Cod. Cache:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoCodigoVendedorCachePesquisa" styleName="labelValidacao"  text="{ignTextInputIntegerCodigoVendedorCachePesquisa.errorString}"/>
					<visual:IgnTextInputInteger id="ignTextInputIntegerCodigoVendedorCachePesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Usuário:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoUsuarioPesquisa" styleName="labelValidacao" text="{ignComboBoxAutoCompleteUsuarioPesquisa.errorString}"/>
					<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteUsuarioPesquisa" dataProvider="{listaUsuarioPesquisa}" labelField="nome" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>		
			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaVendedor"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaVendedor}" doubleClick="datagridListaVendedor_doubleClickHandler(event)" doubleClickEnabled="true">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="empresaFisica.razaoSocial" headerText="Empresa" resizable="true" width="200"/>
						<mx:DataGridColumn dataField="nome" headerText="Nome" resizable="true" width="150"/>
						<mx:DataGridColumn dataField="codigoVendedorCache" headerText="Código do Vendedor Cache" resizable="true"/>
						<mx:DataGridColumn dataField="usuario.nome" headerText="Usuário" resizable="true"/>
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
				
	</mx:Grid>
</s:TitleWindow>
